/*
* Template: src/main/takatuka/templates/EntityPresentationAbstractSearchView.vm
*/
package de.ivu.elect.presentation.internet;

import java.util.List;

import javax.annotation.PostConstruct;
import javax.enterprise.context.RequestScoped;
import javax.enterprise.event.Observes;
import javax.enterprise.event.Reception;
import javax.enterprise.inject.Instance;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;
import org.apache.deltaspike.core.api.scope.ViewAccessScoped;

import de.ivu.elect.business.security.UseCasePermission;

import de.ivu.elect.business.internet.boundary.AbstractInternetSeiteSearchParameters;
import de.ivu.elect.business.internet.boundary.InternetSeiteChangeEvent;
import de.ivu.elect.business.internet.boundary.InternetSeiteConversationStore;
import de.ivu.elect.business.internet.boundary.InternetSeiteExtendedDAO;
import de.ivu.elect.business.internet.boundary.InternetSeiteSearch;
import de.ivu.elect.business.internet.boundary.InternetSeiteSearchParameters;
import de.ivu.elect.business.wahl.boundary.WahlSelectChangeEvent;
import de.ivu.elect.business.wahl.boundary.WahlterminSelectChangeEvent;
import de.ivu.elect.business.internet.entity.InternetSeite;
import de.ivu.elect.business.internet.entity.InternetSeiteMeta;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.presentation.AbstractElectSearchView;
import de.ivu.elect.presentation.View;

@ViewAccessScoped
@Named(AbstractInternetSeiteSearchView.COMPONENT_NAME)
@View(viewId = AbstractInternetSeiteSearchView.VIEW_ID, useCase = UseCasePermission.INTERNET_SEITE_SEARCH)
public abstract class AbstractInternetSeiteSearchView extends AbstractElectSearchView<InternetSeite> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "internetSeiteSearchView";
  
  public static final String VIEW_ID = "/internet/internet-seite-search.xhtml";

  @Inject
  private transient RequestHandlerAbstractInternetSeiteSearchView requestHandler;

  @Inject
  private transient InternetSeiteExtendedDAO extendedDAO;

  @Inject
  @ConversationGroup(InternetSeiteConversationStore.class)
  protected transient InternetSeiteConversationStore conversationStore;

  @Inject
  protected transient InternetSeiteSearch search;

  @Inject
  @ConversationGroup(AbstractInternetSeiteSearchParameters.class)
  protected transient InternetSeiteSearchParameters searchParameters;

  @Inject
  protected transient InternetSeiteMeta entityMeta;

  public AbstractInternetSeiteSearchView() {
    super();
  }

  @Override
  protected String getViewId() {
    return VIEW_ID;
  }

  public boolean isEntitySelected() {
    return conversationStore.getEntityPK() != null;
  }

  public InternetSeite getSelectedEntity() {
    if (isEntitySelected()) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }

    return null;
  }

  public void setSelectedEntity(InternetSeite entity) {
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  @Override
  public InternetSeiteSearchParameters getSearchParameters() {
    return searchParameters;
  }

  public EagerLoadingCollector<InternetSeite> getEagerLoadingCollector() {
    return EagerLoadingCollector.<InternetSeite> create();
  }

  @Override
  public List<InternetSeite> getSearchResult() {
    requestHandler.nothing(); // ELECT-248

    return super.getSearchResult();
  }

  @Override
  protected List<InternetSeite> performSearch() {
    return search.getSearchResult(getSearchParameters(), getEagerLoadingCollector());
  }

  public void onInternetSeiteChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) InternetSeiteChangeEvent event) {
    resetSearchResult();
  }

  // ELECT-2231    ELECT-2250
  /*
   * searchParameters sind von der zur Bearbeitung ausgewählten Wahl abhängig.
   */
  public void onWahlSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlSelectChangeEvent event) {
    reset();
  }

  /*
   * searchParameters sind vom zur Bearbeitung ausgewählten Wahltermin abhängig.
   */
  public void onWahlterminSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlterminSelectChangeEvent event) {
    reset();
  }

  @RequestScoped
  //  Das Suchergebnis soll nur einmal pro Request geladen werden, daher gibt es dieses "Konstrukt" aus "SearchView" und "RequestHandlerAbstract"
  public static class RequestHandlerAbstractInternetSeiteSearchView {

    @View
    @Inject
    private transient Instance<AbstractInternetSeiteSearchView> searchViews;

    @PostConstruct
    public void init() {
      // ELECT-3543 Doppelte Suchen vermeiden - Suchergebnis für Request nicht beim POST-löschen
      if (!FacesContext.getCurrentInstance().isPostback()) {
        for (AbstractInternetSeiteSearchView searchView : searchViews) {
          searchView.resetSearchResult();
        }
      }
    }

    public void nothing() {
      // Do nothing.
    }
  }
}
